/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/base/assert','sap/base/Log','sap/base/strings/formatMessage','sap/base/util/Properties','sap/base/util/merge'],function(a,L,f,P,b){"use strict";var r=/^((?:[A-Z]{2,3}(?:-[A-Z]{3}){0,3})|[A-Z]{4}|[A-Z]{5,8})(?:-([A-Z]{4}))?(?:-([A-Z]{2}|[0-9]{3}))?((?:-[0-9A-Z]{5,8}|-[0-9][0-9A-Z]{3})*)((?:-[0-9A-WYZ](?:-[0-9A-Z]{2,8})+)*)(?:-(X(?:-[0-9A-Z]{1,8})+))?$/i;var M={"he":"iw","yi":"ji","id":"in","sr":"sh","nb":"no"};var c={"iw":"he","ji":"yi","in":"id","sh":"sr","no":"nb"};var d={"en_US_saptrc":"1Q","en_US_sappsd":"2Q"};var D="en";var e=/(?:^|-)(saptrc|sappsd)(?:-|$)/i;function n(i,x){var m;if(typeof i==='string'&&(m=r.exec(i.replace(/_/g,'-')))){var y=m[1].toLowerCase();if(!x){y=M[y]||y;}var S=m[2]?m[2].toLowerCase():undefined;var z=m[3]?m[3].toUpperCase():undefined;var V=m[4]?m[4].slice(1):undefined;var B=m[6];if((B&&(m=e.exec(B)))||(V&&(m=e.exec(V)))){return"en_US_"+m[1].toLowerCase();}if(y==="zh"&&!z){if(S==="hans"){z="CN";}else if(S==="hant"){z="TW";}}return y+(z?"_"+z+(V?"_"+V.replace("-","_"):""):"");}}function g(i,m){if(i===""){return i;}var N=n(i,m);if(N===undefined){throw new TypeError("Locale '"+i+"' is not a valid BCP47 language tag");}return N;}function h(F){var i;if(window.sap&&window.sap.ui&&sap.ui.getCore){i=sap.ui.getCore().getConfiguration().getLanguage();i=n(i);}return i||F;}function j(){if(window.sap&&window.sap.ui&&sap.ui.getCore){return sap.ui.getCore().getConfiguration().getSupportedLanguages();}return[];}function k(i){var m;if(typeof i==='string'&&(m=r.exec(i.replace(/_/g,'-')))){var x=m[1].toLowerCase();x=c[x]||x;return x+(m[3]?"-"+m[3].toUpperCase()+(m[4]?"-"+m[4].slice(1).replace("_","-"):""):"");}}var l=/^((?:[^?#]*\/)?[^\/?#]*)(\.[^.\/?#]+)((?:\?([^#]*))?(?:#(.*))?)$/;var A=[".properties",".hdbtextbundle"];function s(U){var m=l.exec(U);if(!m||A.indexOf(m[2])<0){throw new Error("resource URL '"+U+"' has unknown type (should be one of "+A.join(",")+")");}return{url:U,prefix:m[1],ext:m[2],query:m[4],hash:(m[5]||""),suffix:m[2]+(m[3]||"")};}function R(U,i,I,m,S,F,x){this.sLocale=n(i)||h(F===undefined?D:F);this.oUrlInfo=s(U);this.bIncludeInfo=I;this.aCustomBundles=[];this.aPropertyFiles=[];this.aLocales=[];this._aFallbackLocales=w(this.sLocale,S||j(),F," of the bundle '"+this.oUrlInfo.url+"'",x);if(m){var y=function(){return this;}.bind(this);return o(this).then(y,y);}p(this);}R.prototype._enhance=function(C){if(C instanceof R){this.aCustomBundles.push(C);}else{L.error("Custom resource bundle is either undefined or not an instanceof sap/base/i18n/ResourceBundle. Therefore this custom resource bundle will be ignored!");}};R.prototype.getText=function(K,i,I){var V=this._getTextFromProperties(K,i);if(V!=null){return V;}V=this._getTextFromFallback(K,i);if(V!=null){return V;}a(false,"could not find any translatable text for key '"+K+"' in bundle '"+this.oUrlInfo.url+"'");if(I){return undefined;}else{return this._formatValue(K,K,i);}};R.prototype._formatValue=function(V,K,i){if(typeof V==="string"){if(i){V=f(V,i);}if(this.bIncludeInfo){V=new String(V);V.originInfo={source:"Resource Bundle",url:this.oUrlInfo.url,locale:this.sLocale,key:K};}}return V;};R.prototype._getTextFromFallback=function(K,m){var V,i;for(i=this.aCustomBundles.length-1;i>=0;i--){V=this.aCustomBundles[i]._getTextFromFallback(K,m);if(V!=null){return V;}}while(typeof V!=="string"&&this._aFallbackLocales.length){var x=p(this);if(x){V=x.getProperty(K);if(typeof V==="string"){return this._formatValue(V,K,m);}}}return null;};R.prototype._getTextFromProperties=function(K,m){var V=null,i;for(i=this.aCustomBundles.length-1;i>=0;i--){V=this.aCustomBundles[i]._getTextFromProperties(K,m);if(V!=null){return V;}}for(i=0;i<this.aPropertyFiles.length;i++){V=this.aPropertyFiles[i].getProperty(K);if(typeof V==="string"){return this._formatValue(V,K,m);}}return null;};R.prototype.hasText=function(K){return this.aPropertyFiles.length>0&&typeof this.aPropertyFiles[0].getProperty(K)==="string";};function o(B){if(B._aFallbackLocales.length){return t(B,true).then(function(i){return i||o(B);});}return Promise.resolve(null);}function p(B){while(B._aFallbackLocales.length){var i=t(B,false);if(i){return i;}}return null;}function t(B,i){var m=B._aFallbackLocales.shift();if(m!=null){var U=B.oUrlInfo,x,H;if(U.ext==='.hdbtextbundle'){if(d[m]){x=U.prefix+U.suffix+'?'+(U.query?U.query+"&":"")+"sap-language="+d[m]+(U.hash?"#"+U.hash:"");}else{x=U.url;}H={"Accept-Language":k(m)||""};}else{x=U.prefix+(m?"_"+m:"")+U.suffix;}var y=P.create({url:x,headers:H,async:!!i,returnNullIfMissing:true});var z=function(C){if(C){B.aPropertyFiles.push(C);B.aLocales.push(m);}return C;};return i?y.then(z):z(y);}return i?Promise.resolve(null):null;}R._getUrl=function(i,m){var U=i;if(m){m=m.replace(/\./g,"/");U=sap.ui.require.toUrl(m)+".properties";}return U;};function q(i,E,m,I,x,F,S){if(!E){return[];}var C=[];E.forEach(function(y){if(y.fallbackLocale===undefined){y.fallbackLocale=F;}if(y.supportedLocales===undefined){y.supportedLocales=S;}var U=R._getUrl(y.bundleUrl,y.bundleName);var z=new R(U,m,I,x,y.supportedLocales,y.fallbackLocale);C.push(z);if(y.terminologies){C=C.concat(u(i,y.terminologies,m,I,x));}});return C;}function u(i,T,m,I,x){if(!i){return[];}i=i.filter(function(y){return T.hasOwnProperty(y);});i.reverse();return i.map(function(y){var z=T[y];var U=R._getUrl(z.bundleUrl,z.bundleName);var S=z.supportedLocales;return new R(U,m,I,x,S,null,true);});}R.create=function(m){m=b({url:"",includeInfo:false},m);if(m.bundleUrl||m.bundleName){m.url=m.url||R._getUrl(m.bundleUrl,m.bundleName);}var i=new R(m.url,m.locale,m.includeInfo,!!m.async,m.supportedLocales,m.fallbackLocale);var C=[];if(m.terminologies){C=C.concat(u(m.activeTerminologies,m.terminologies,m.locale,m.includeInfo,!!m.async));}if(m.enhanceWith){C=C.concat(q(m.activeTerminologies,m.enhanceWith,m.locale,m.includeInfo,!!m.async,m.fallbackLocale,m.supportedLocales));}if(C.length){if(i instanceof Promise){i=i.then(function(x){return Promise.all(C).then(function(C){C.forEach(x._enhance,x);}).then(function(){return x;});});}else{C.forEach(i._enhance,i);}}return i;};function v(i,S){if(!S||S.length===0||S.indexOf(i)>=0){return i;}i=k(i);if(i){i=n(i,true);}if(S.indexOf(i)>=0){return i;}return undefined;}function w(i,S,F,C,m){S=S&&S.map(function(B){return g(B,true);});if(!m){var x=F!==undefined;F=x?F:D;F=g(F);if(F!==""&&!v(F,S)){var y="The fallback locale '"+F+"' is not contained in the list of supported locales ['"+S.join("', '")+"']"+C+" and will be ignored.";if(x){throw new Error(y);}L.error(y);}}var z=[],B;while(i!=null){B=v(i,S);if(B!==undefined&&z.indexOf(B)===-1){z.push(B);}if(!i){i=null;}else if(i==="zh_HK"){i="zh_TW";}else if(i.lastIndexOf('_')>=0){i=i.slice(0,i.lastIndexOf('_'));}else if(m){i=null;}else if(F){i=F;F=null;}else{i="";}}return z;}R._getFallbackLocales=function(i,S,F){return w(n(i),S,F,"");};return R;});
