/*
 * ! OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/fl/write/_internal/appVariant/AppVariantFactory","sap/ui/fl/apply/_internal/appVariant/DescriptorChangeTypes","sap/ui/fl/write/_internal/appVariant/AppVariantInlineChangeFactory","sap/ui/fl/apply/_internal/ChangesController","sap/ui/fl/Utils","sap/base/Log","sap/ui/fl/Layer","sap/base/util/includes","sap/base/util/merge","sap/base/util/restricted/_omit","sap/ui/fl/registry/Settings"],function(A,D,a,C,U,L,b,i,m,_,S){"use strict";function c(P){return S.getInstance().then(function(s){if(!P.package&&(P.layer===b.VENDOR||(P.layer===b.CUSTOMER_BASE&&!s.isAtoEnabled()))){return Promise.reject("Package must be provided or is valid");}if(P.isForSmartBusiness&&(P.package!=='$TMP'&&P.package!=='')&&!P.transport&&!s.isAtoEnabled()){return Promise.reject("Transport must be provided");}if(P.isForSmartBusiness&&P.transport||(P.package==="$TMP")){return Promise.resolve({packageName:P.package,transport:P.transport});}return Promise.resolve({packageName:"",transport:""});});}function d(q,t){var T=t.transport?q.setTransportRequest(t.transport):Promise.resolve();return T.then(function(){if(t.packageName){return q.setPackage(t.packageName);}return Promise.resolve();});}function e(q){var I=[];q.forEach(function(r){var s=r.getDefinition();var t={changeType:s.changeType,content:s.content};if(s.texts){t.texts=s.texts;}I.push(a.createNew(t));});return Promise.all(I);}function f(q,r){var P={reference:r.getId()};var s=U.createNamespace(P,"changes");q.setNamespace(s);q.setComponent(r.getId());if(r.getVersion()){q.setValidAppVersions({creation:r.getVersion(),from:r.getVersion()});}}function g(q,r){var s=[];q.forEach(function(I){I.replaceHostingIdForTextKey(r.getId(),r.getReference(),I.getContent(),I.getTexts());s.push(r.addDescriptorInlineChange(I));});return Promise.all(s);}function h(s){var q=C.getDescriptorFlexControllerInstance(s)._oChangePersistence;if(q){var r=q.getDirtyChanges();r=r.slice();return r;}return[];}function j(s){var F=C.getFlexControllerInstance(s)._oChangePersistence;if(F){var u=F.getDirtyChanges();u=u.slice();return u;}return[];}function k(s){var F=C.getFlexControllerInstance(s)._oChangePersistence;var q=C.getDescriptorFlexControllerInstance(s)._oChangePersistence;return F===q;}function l(s,q,r){var t=[];if(q){h(s).forEach(function(u){if(i(D.getChangeTypes(),u.getDefinition().changeType)){t.push(u);}else{f(u,r);}});}else{j(s).forEach(function(u){f(u,r);});t=h(s);}return t;}function n(s){h(s).forEach(function(q){if(i(D.getChangeTypes(),q.getChangeType())){C.getDescriptorFlexControllerInstance(s)._oChangePersistence.deleteChange(q);}});}function o(q,P){if(!q){throw new Error("App variant with ID: "+P.id+"does not exist");}P.package=q.getPackage();P.layer=q.getDefinition().layer;return c(P).then(function(t){return d(q,t);}).then(function(){return q;});}var p={saveAs:function(P){var q;var r;var s=false;return A.prepareCreate(P).then(function(t){q=m({},t);return c(P);}).then(function(t){return d(q,t);}).then(function(){s=k(P.selector);var t=l(P.selector,s,q);return e(t);}).then(function(t){return g(t,q);}).then(function(){return q.submit().catch(function(E){E.messageKey="MSG_SAVE_APP_VARIANT_FAILED";throw E;});}).then(function(R){r=m({},R);if(s){n(P.selector);}var F=C.getFlexControllerInstance(P.selector);var u=j(P.selector);if(u.length){return F.saveAll(C.getAppComponentForSelector(P.selector),true).catch(function(E){if(s){n(P.selector);}return this.deleteAppVariant({id:P.id}).then(function(){E.messageKey="MSG_COPY_UNSAVED_CHANGES_FAILED";throw E;});}.bind(this));}return Promise.resolve();}.bind(this)).then(function(){if(!s){n(P.selector);}return r;}).catch(function(E){if(h(P.selector).length){n(P.selector);}L.error("the app variant could not be created.",E.message||E);throw E;});},updateAppVariant:function(P){var q;var r;return A.prepareUpdate(_(P,"selector")).catch(function(E){E.messageKey="MSG_LOAD_APP_VARIANT_FAILED";throw E;}).then(function(s){if(!s){throw new Error("App variant with ID: "+P.id+"does not exist");}q=m({},s);P.package=q.getPackage();P.layer=q.getDefinition().layer;return c(P);}).then(function(t){return d(q,t);}).then(function(){var s=[];h(P.selector).forEach(function(t){if(i(D.getChangeTypes(),t.getDefinition().changeType)){s.push(t);}});return e(s);}).then(function(s){return g(s,q);}).then(function(){return q.submit().catch(function(E){if(P.isForSmartBusiness){n(P.selector);throw E;}E.messageKey="MSG_UPDATE_APP_VARIANT_FAILED";throw E;});}).then(function(R){r=m({},R);n(P.selector);return r;}).catch(function(E){if(h(P.selector).length){n(P.selector);}L.error("the app variant could not be updated.",E.message||E);throw E;});},deleteAppVariant:function(P){return A.prepareDelete(_(P,"selector")).catch(function(E){E.messageKey="MSG_LOAD_APP_VARIANT_FAILED";throw E;}).then(function(q){return((P.isForSmartBusiness)?Promise.resolve(q):o(q,P));}).then(function(q){return q.submit().catch(function(E){if(E==="cancel"){return Promise.reject("cancel");}E.messageKey="MSG_DELETE_APP_VARIANT_FAILED";throw E;});}).catch(function(E){if(E==="cancel"){return Promise.reject("cancel");}L.error("the app variant could not be deleted.",E.message||E);throw E;});}};return p;},true);
